import { type LucidModel, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type Filter } from '../types.js';
export declare class FiltersCallback<Model extends LucidModel> implements Filter<Model> {
    private callback;
    constructor(callback: (query: ModelQueryBuilderContract<Model>, value: unknown, property: string) => void);
    handle(query: ModelQueryBuilderContract<Model, InstanceType<Model>>, value: unknown, property: string): void;
}
