import { type LucidModel, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { Collection } from 'collect.js';
import { type Include } from '../types.js';
export declare class IncludedRelationship<ParentModel extends LucidModel> implements Include<ParentModel> {
    static getIndividualRelationshipPathsFromInclude(include: string): Collection<string>;
    getRequestedFieldsForRelatedTable?: (relationship: string) => string[];
    handle(query: ModelQueryBuilderContract<ParentModel, InstanceType<ParentModel>>, relationship: string): void;
    private buildNestedQuery;
}
