import { type LucidModel, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type Sort } from '../types.js';
export declare class SortsCallback<Model extends LucidModel> implements Sort<Model> {
    private readonly _callback;
    constructor(_callback: (query: ModelQueryBuilderContract<Model>, descending: boolean, property: string) => void);
    handle(query: ModelQueryBuilderContract<Model>, descending: boolean, property: string): void;
}
